module rnd;
//import std.stdio;
import std.random;
public enum Randomize = 0xFFFF_FFFF;
struct Rnd{
static :
	private Mt19937 buf;
	private uint DefaultMax = 0xFFFF_FFFF;
	private uint CurSeed = 0;

	//Rnd.seed = Randomize;とすることで、unpredictableSeedを用いる
	//Randomize以外で0xFFFF_FFFFは指定しないようにすること！！
	void seed(uint seed){
		if (seed == Randomize) {
			CurSeed = unpredictableSeed;
			buf.seed = CurSeed;		//Randomize
		} else {
			CurSeed = seed;
			buf.seed = seed;		//明示的なシードの設定
		}
	}
	//現在のseed値を返す。
	uint seed(){
		return CurSeed;
	}
	//初期化する(乱数列をはじめに戻す)
	void init(){
		buf.seed = CurSeed;
	}
	//乱数を一つ得て数列を一つ進める。
	//引数によって最大値を指定する。
	//省略した場合はRnd.maxで定められた値になる。
	uint get(uint max = 0xFFFF_FFFF){
		if (max == 0xFFFF_FFFF) {		//DefaultMaxをmaxとするとき
			buf.popFront();
			return buf.front() % DefaultMax;
		} else {		//毎回指定する時
			buf.popFront();
			return buf.front() % max;
		}
	}
	void max(uint max){
		DefaultMax = max;
	}
	//指定回数popFrontする
	void popFront(uint num = 1){
		for(int i; i < num; i++){
			buf.popFront();
		}
	}
}
/*
void main(){
	Rnd.seed = Randomize;
	Rnd.max = 1000;
	writeln(Rnd.get(100));
	for(int i; i < 10000; i++){
		writeln(Rnd.get);
	}
}
*/
